package frc.robot.interfaces;

import java.util.function.DoubleSupplier;

import edu.wpi.first.wpilibj2.command.Command;

public interface IPIDFMotorSubsystem {
    public boolean atSetpoint();

    public Command goToSetpoint(DoubleSupplier setpoint);

    public default Command goToSetpointAndStop(DoubleSupplier setpoint) {
        return goToSetpoint(setpoint)
                .until(this::atSetpoint);
    }

    public default Command goToSetpointAndStop(DoubleSupplier setpoint, double timeout) {
        return goToSetpointAndStop(setpoint)
                .withTimeout(timeout);
    }

    public Command maintainPosition();
}
