package frc.robot.utilities;

import edu.wpi.first.util.sendable.Sendable;
import edu.wpi.first.util.sendable.SendableBuilder;

public class PIDValues implements Sendable {
    private double p;
    private double i;
    private double d;
    private double tolerance;

    public PIDValues(double p, double tolerance) {
        this(p, 0, tolerance);
    }

    public PIDValues(double p, double d, double tolerance) {
        this(p, 0, d, tolerance);
    }

    public PIDValues(double p, double i, double d, double tolerance) {
        this.p = p;
        this.i = i;
        this.d = d;
        this.tolerance = tolerance;
    }

    public void setP(double p) {
        this.p = p;
    }

    public void setI(double i) {
        this.i = i;
    }

    public void setD(double d) {
        this.d = d;
    }

    public void setTolerance(double tolerance) {
        this.tolerance = tolerance;
    }

    public double getP() {
        return p;
    }

    public double getI() {
        return i;
    }

    public double getD() {
        return d;
    }

    public double getTolerance() {
        return tolerance;
    }

    @Override
    public void initSendable(SendableBuilder builder) {
        builder.addDoubleProperty("P", this::getP, this::setP);
        builder.addDoubleProperty("I", this::getI, this::setI);
        builder.addDoubleProperty("D", this::getD, this::setD);
        builder.addDoubleProperty("Tolerance", this::getTolerance, this::setTolerance);
    }
}
