package frc.robot.utilities;

import java.util.function.BooleanSupplier;
import java.util.function.Consumer;

public class ValueEnforcer {
    private BooleanSupplier shouldEnforce;

    private double valueToEnforce;

    public ValueEnforcer(BooleanSupplier shouldEnforce, double valueToEnforce) {
        this.shouldEnforce = shouldEnforce;
        this.valueToEnforce = valueToEnforce;
    }

    public boolean checkAndEnforce(Consumer<Double> setValue) {
        if (shouldEnforce.getAsBoolean()) {
            setValue.accept(valueToEnforce);
            return true;
        }

        return false;
    }
}
